regina::NVector< T > Class Template Reference
Mathematical Support

An optimised vector class of elements from a given ring T. More...

`#include <maths/nvector.h>`

## Public Member Functions

| NVector (size_t newVectorSize)
| Creates a new vector. More...
| NVector (size_t newVectorSize, const T &initValue)
| Creates a new vector and initialises every element to the given value. More...
| NVector (const NVector< T > &cloneMe)
| Creates a new vector that is a clone of the given vector. More...
| ~NVector ()
| Destroys this vector. More...
size_t | size () const
| Returns the number of elements in the vector. More...
const T & | operator[] (size_t index) const
| Returns the element at the given index in the vector. More...
void | setElement (size_t index, const T &value)
| Sets the element at the given index in the vector to the given value. More...
bool | operator== (const NVector< T > &compare) const
| Determines if this vector is equal to the given vector. More...
NVector< T > & | operator= (const NVector< T > &cloneMe)
| Sets this vector equal to the given vector. More...
void | operator+= (const NVector< T > &other)
| Adds the given vector to this vector. More...
void | operator-= (const NVector< T > &other)
| Subtracts the given vector from this vector. More...
void | operator*= (const T &factor)
| Multiplies this vector by the given scalar. More...
T | operator* (const NVector< T > &other) const
| Calculates the dot product of this vector and the given vector. More...
void | negate ()
| Negates every element of this vector. More...
T | norm () const
| Returns the norm of this vector. More...
T | elementSum () const
| Returns the sum of all elements of this vector. More...
void | addCopies (const NVector< T > &other, const T &multiple)
| Adds the given multiple of the given vector to this vector. More...
void | subtractCopies (const NVector< T > &other, const T &multiple)
| Subtracts the given multiple of the given vector to this vector. More...

## Static Public Attributes

static T | zero
| Zero in the underlying number system. More...
static T | one
| One in the underlying number system. More...
static T | minusOne
| Negative one in the underlying number system. More...

## Protected Attributes

T * | elements
| The internal array containing all vector elements. More...
T * | end
| A pointer just beyond the end of the internal array. More...

## Detailed Description

### template<class T>
class regina::NVector< T >

An optimised vector class of elements from a given ring T.

Various mathematical vector operations are available.

This class is intended for serious computation, and as a result it has a streamlined implementation with no virtual methods. It can be subclassed, but since there are no virtual methods, type information must generally be known at compile time. Nevertheless, in many respects, different subclasses of NVector<T> can happily interact with one another.

This class is written with bulky types in mind (such as arbitrary precision integers), and so creations and operations are kept to a minimum.

Warning
  As of Regina 4.90, this class merges the old functionality of NFastVector and the NVector hierarchy from Regina 4.6. As a side-effect, the hierarchy has been compressed into just one class (NVectorUnit, NVectorMatrix and NVectorDense are gone), elements are always stored as dense vectors, and functions are no longer virtual (since the storage model is now fixed). The virtual clone() method is gone completely (since there are no longer virtual functions you should use the copy constructor instead), and the old makeLinComb() method is also gone (just use operator *= and addCopies()).

Precondition
  Type T has a copy constructor. That is, if `a` and `b` are of type T, then `a` can be initialised to the value of `b` using `a(b)`.
  Type T has a default constructor. That is, an object of type T can be declared with no arguments. No specific default value is required.
  Type T allows for operators `=`, `==`, `+=`, `-=` and `*=`.
  Type T has a long integer constructor. That is, if `a` is of type T, then `a` can be initialised to a long integer `l` using `a(l)`.
  An element `t` of type T can be written to an output stream `out` using the standard expression `out << t`.

Python:
  Not present.

## Constructor & Destructor Documentation

template<class T>

regina::NVector< T >::NVector | ( | size_t | newVectorSize | ) |

inline

Creates a new vector.

Its elements will not be initialised.

Parameters

  newVectorSize | the number of elements in the new vector; this must be strictly positive.

template<class T>

regina::NVector< T >::NVector | ( | size_t | newVectorSize,
|  | const T & | initValue
| ) |  |

inline

Creates a new vector and initialises every element to the given value.

Parameters

  newVectorSize | the number of elements in the new vector; this must be strictly positive.
  initValue | the value to assign to every element of the vector.

template<class T>

regina::NVector< T >::NVector | ( | const NVector< T > & | cloneMe | ) |

inline

Creates a new vector that is a clone of the given vector.

Parameters

  cloneMe | the vector to clone.

template<class T>

regina::NVector< T >::~NVector | ( |  | ) |

inline

Destroys this vector.

## Member Function Documentation

template<class T>

void regina::NVector< T >::addCopies | ( | const NVector< T > & | other,
|  | const T & | multiple
| ) |  |

inline

Adds the given multiple of the given vector to this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector a multiple of which will be added to this vector.
  multiple | the multiple of other to be added to this vector.

template<class T>

T regina::NVector< T >::elementSum | ( |  | ) | const

inline

Returns the sum of all elements of this vector.

Returns
  the sum of the elements of this vector.

template<class T>

void regina::NVector< T >::negate | ( |  | ) |

inline

Negates every element of this vector.

template<class T>

T regina::NVector< T >::norm | ( |  | ) | const

inline

Returns the norm of this vector.

This is the dot product of the vector with itself.

Returns
  the norm of this vector.

template<class T>

T regina::NVector< T >::operator* | ( | const NVector< T > & | other | ) | const

inline

Calculates the dot product of this vector and the given vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector with which this will be multiplied.

Returns
  the dot product of this and the given vector.

template<class T>

void regina::NVector< T >::operator*= | ( | const T & | factor | ) |

inline

Multiplies this vector by the given scalar.

Parameters

  factor | the scalar with which this will be multiplied.

template<class T>

void regina::NVector< T >::operator+= | ( | const NVector< T > & | other | ) |

inline

Adds the given vector to this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector to add to this vector.

template<class T>

void regina::NVector< T >::operator-= | ( | const NVector< T > & | other | ) |

inline

Subtracts the given vector from this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector to subtract from this vector.

template<class T>

NVector<T>& regina::NVector< T >::operator= | ( | const NVector< T > & | cloneMe | ) |

inline

Sets this vector equal to the given vector.

Precondition
  This and the given vector have the same size.

Parameters

  cloneMe | the vector whose value shall be assigned to this vector.

template<class T>

bool regina::NVector< T >::operator== | ( | const NVector< T > & | compare | ) | const

inline

Determines if this vector is equal to the given vector.

Precondition
  This and the given vector have the same size.

Parameters

  compare | the vector with which this will be compared.

Returns
  `true` if and only if the this and the given vector are equal.

template<class T>

const T& regina::NVector< T >::operator[] | ( | size_t | index | ) | const

inline

Returns the element at the given index in the vector.

A constant reference to the element is returned; the element may not be altered.

Precondition
  `index` is between 0 and size()-1 inclusive.

Parameters

  index | the vector index to examine.

Returns
  the vector element at the given index.

template<class T>

void regina::NVector< T >::setElement | ( | size_t | index,
|  | const T & | value
| ) |  |

inline

Sets the element at the given index in the vector to the given value.

Precondition
  `index` is between 0 and size()-1 inclusive.

Parameters

  index | the vector index to examine.
  value | the new value to assign to the element.

Returns
  the vector element at the given index.

template<class T>

size_t regina::NVector< T >::size | ( |  | ) | const

inline

Returns the number of elements in the vector.

Returns
  the vector size.

template<class T>

void regina::NVector< T >::subtractCopies | ( | const NVector< T > & | other,
|  | const T & | multiple
| ) |  |

inline

Subtracts the given multiple of the given vector to this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector a multiple of which will be subtracted from this vector.
  multiple | the multiple of other to be subtracted from this vector.

## Member Data Documentation

template<class T>

T* regina::NVector< T >::elements

protected

The internal array containing all vector elements.

template<class T>

T* regina::NVector< T >::end

protected

A pointer just beyond the end of the internal array.

The size of the vector can be computed as (end - elements).

The documentation for this class was generated from the following file:

- maths/nvector.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).